#!/usr/bin/perl
package classifyReads;
#var: inputFile, inputFileType
require verifyPath;
sub main{
	#print "classifyReads\t";
	shift (@_);
	my ($input,$intputType,$outPrefix) = @_;
	$input = verifyPath->inPath($input);
	my $outPutMM = "$outPrefix.mm";
	my $outPutUM = "$outPrefix.um";
	my $outPutNM = "$outPrefix.nm";
	
	if   ($intputType eq "e"){getExtend($input,$outPutMM,$outPutUM,$outPutNM);}
	elsif($intputType eq "E"){getEland($input,$outPutMM,$outPutUM,$outPutNM);}
	elsif($intputType eq "r"){getBowtieR($input,$outPutMM,$outPutUM);}
	elsif($intputType eq "q"){getBowtieQ($input,$outPutMM,$outPutUM);}
	else{ 
		print "input file extension should be specified\n";
		print "e: input file is extended eland file\n";
		print "E: input file is eland file\n"; 
		print "r: input file is bowtie -r result\n";
		print "q: input file is bowtie -q result\n";
		exit 0;
	}
	#print "finished\n";
	return ($outPutMM,$outPutUM,$outPutNM);
}
sub getExtend{
	my ($input,$outM,$outU,$outN) = @_;
	open(IN,$input) or die "Can not open $input\n";
	open(OUT_1,">$outM");
	open(OUT_2,">$outU");
	open(OUT_3,">$outN");
	my @reads=();
	while (my $line=<IN>){
		chomp($line);
		@reads=split(/\s+/,$line);	
		unless ($reads[2] eq "QC"){
			if($reads[2] eq "NM"){
				syswrite(OUT_3,$reads[0]."\t".$reads[1]."\t".$reads[2]."\t".$reads[3]."\n");
				next;
			}	
			@temp=split(/,/,$reads[3]);
			$counter=@temp;
			unless($reads[3] == "-"){
				if ($counter == 1){
					syswrite(OUT_2,$reads[0]."\t".$reads[1]."\t".$reads[2]."\t".$reads[3]."\n");
				}		
				else{ 
					syswrite(OUT_1,$reads[0]."\t".$reads[1]."\t".$reads[2]."\t".$reads[3]."\n");
				}
			}
			else {
				syswrite(OUT_1,$reads[0]."\t".$reads[1]."\t".$reads[2]."\n");
			}
		}
	}
	close(IN);	
	close(OUT_1);
	close(OUT_2);
	close(OUT_3);	
}
sub getEland{
	my ($input,$outM,$outU,$outN) = @_;
	open(IN,$input) or die "Can not open $input\n";
	open(OUT_1,">$outM");
	open(OUT_2,">$outU");
	open(OUT_3,">$outN");
	my @reads=();
	while (my $line=<IN>){
	    chomp($line);
	    @reads=split(/\s+/,$line);
	    if ($reads[2] == 0){
		syswrite(OUT_3,$line."\n");
	    }		
	    elsif($reads[2]==1){ 
		syswrite(OUT_2,$line."\n");
	    }
	    else{
		syswrite(OUT_1,$line."\n");
	    }
	}
	close(IN);	
	close(OUT_1);
	close(OUT_2);
	close(OUT_3);
}

sub getBowtieR{
	my ($input,$outM,$outU) = @_;
	open(IN,$input) or die "Can not open $input\n";
	open(OUT_1,">$outM");
	open(OUT_2,">$outU");	
	my @row=();

	$line=<IN>;chomp($line);
	@row=split(/\s+/,$line);
	$temp_id=$row[0];
	$temp=$line;
	$tmp[0]=$line;
	my $counter=1;
	while($line=<IN>){
		chomp($line);
		@row=split(/\s+/,$line);
		if($row[0] eq $temp_id){
			$tmp[$counter]=$line;
			$counter++;
			next;
		}
		else{
			if($counter == 1){
				$temp_id=$row[0];
				
				syswrite OUT_2,$temp."\n";
			}
			else{
				
				for($i=0;$i<=$counter-1;$i++){
					
					syswrite OUT_1,$tmp[$i]."\n";
				}
			
				$temp_id=$row[0];
				$counter=1;
			}
			$temp=$line;
			$tmp[0]=$line;
		}
	}
	if($counter == 1){
		syswrite OUT_2,$temp."\n";
	}
	else{
		
		for($i=0;$i<=$counter-1;$i++){
			
			syswrite OUT_1,$tmp[$i]."\n";
		}
	}
	close(IN);
	close(OUT_1);
	close(OUT_2);
}
sub getBowtieQ{
	my ($input,$outM,$outU) = @_;

	open(IN,$input) or die "Can not open $input\n";
	open(OUT_1,">$outM");
	open(OUT_2,">$outU");
	
	my @row=();

	$line=<IN>;
	chomp($line);
	@row=split(/\s+/,$line);
	$temp_id=$row[0];
	$temp=$line;
	$tmp[0]=$line;

	$counter=1;
	while($line=<IN>){
		chomp($line);
		@row=split(/\s+/,$line);
		if($row[0] eq $temp_id){
			$tmp[$counter]=$line;
			$counter++;
			next;
		}
		else{
			if($counter == 1){
				$temp_id=$row[0];
				syswrite OUT_2,$temp."\n";
			}
			else{
				for($i=0;$i<=$counter-1;$i++){
					syswrite OUT_1,$tmp[$i]."\n";
				}
			
				$temp_id=$row[0];
				$counter=1;
			}
			$temp=$line;
			$tmp[0]=$line;
		}
	}
	if($counter == 1){
		syswrite OUT_2,$temp."\n";
	}
	else{
	
		for($i=0;$i<=$counter-1;$i++){
			$count++;
			syswrite OUT_1,$tmp[$i]."\n";
		}
	}
	close(IN);
	close(OUT_1);
	close(OUT_2);
}
1;