#!/usr/bin/perl

if($ARGV[0] eq ""){
	print "Usage: getSeq.pl [options] INPUT FILE\n";
	print "options: \n";
	print "-e  Use -e option if input file is in extended eland file format\n";
	print "-l  Use -l option if input file is in eland file format\n";
	print "-q  Use -q option if input file is in fastq file format\n";

	print "-p Use -x option if input file is in export file format\n";
	
	print "-c Use -c option to specify the column position of sequence\n";
	print "e.g. -c 1 means the squence to be retrieved locates in the first column of input data file\n";
}
use Getopt::Long;

#setup my defaults
my $e;
my $l;
my $q;
my $x;
my $c = 0;


GetOptions(
	'e!'   => \$e,
	'l!'   => \$l,
	'q!'   => \$q,
	'x!'   => \$x,
	'c=i'   => \$c,
	) or die "Incorrect usage!\n";

=cut
print "e is $e\n";	
print "l is $l\n";	
print "q is $q\n";	
print "x is $x\n";		
print "c is $c\n";
=cut
	

open(IN,$ARGV[0]);

#print "argv[0] is $ARGV[0]\n";

#absolute path of input file
@name=split(/\//,$ARGV[0]);
$ilen=@name; #length of input directory
use Cwd;

if($ilen == 1){
        $idir=getcwd();
}
else{

        $str=substr($ARGV[0],0,1);
        #print "!!!! $str\n";
        if($str eq "/"){#use abs_path
                $idir="/".$name[1];
                for($i=2;$i<=$ilen-2;$i++){
                        $idir=$idir."/".$name[$i];
                }
                

        }
        else{          
                $idir=$name[0];
                for($i=1;$i<=$ilen-2;$i++){
                        $idir=$idir."/".$name[$i];
                }

        }
}

chdir($idir);
$idir=getcwd();#absolute path of input file

#print "idir is $idir\n";

open(OUT,">$idir/$name[-1]_seq");



if($e){	
	while($line=<IN>){
		chomp($line);
		@row = split(/\s+/,$line);
		syswrite(OUT,$row[1]."\n");
	}
}

if($l){
	while($line=<IN>){
		chomp($line);
		@row = split(/\s+/,$line);
		syswrite(OUT,$row[1]."\n");
	}	
}

if($q){
	$i = 1;
	while($line=<IN>){
		if($i % 4 == 2 ){
			chomp($line);
			syswrite(OUT,$line."\n");
		}
		$i++;
	}
}



if($x){
	while($line=<IN>){
		chomp($line);
		@row = split(/\s+/,$line);
		syswrite(OUT,$row[8]."\n");
	}
}

if($c != 0){
	while($line=<IN>){
		chomp($line);
		@row = split(/\s+/,$line);
		syswrite(OUT,$row[$c-1]."\n");
	}
}



close(IN);
close(OUT);




