#!/usr/bin/perl
package pickHighestScore;
sub main{
	shift @_;
	my ($input,$w,$p) = @_;
	open(IN,$input) or die "Can not open file $input \n";

	my $line=<IN>;chomp($line);
	my $lineNo = 1;
	my %HSInfo = getInfo($line,$lineNo);# highest score
	
	open(OUT,">$input.HS.bed");
	while($line=<IN>){
		chomp($line);
		$lineNo +=1;
		my %tmpInfo = getInfo($line,$lineNo);
		# print if find a different id
		if ($tmpInfo{"id"} ne $HSInfo{"id"}){
			#%printInfo = %HSInfo;
			print OUT join("\t",$HSInfo{"chr"},$HSInfo{"start"},$HSInfo{"end"},$HSInfo{"id"},$HSInfo{"strand"}) . "\n";
		}
		# update if find a different id or a greater score of the same id
		unless ( ($tmpInfo{"id"} eq $HSInfo{"id"}) && ($tmpInfo{"score"} le $HSInfo{"score"}) ){
			%HSInfo = %tmpInfo;
		}		
	}
	# print the last updated HS info (either a line with new id or same id with highest score)
	print OUT join("\t",$HSInfo{"chr"},$HSInfo{"start"},$HSInfo{"end"},$HSInfo{"id"},$HSInfo{"strand"}) . "\n";
	close(IN);
	close(OUT);
}

sub getInfo{
	my @vars = @_;
	my @col=split(/\s+/,$vars[0]);
	if ($#col  < 12) {die "Missing columns at line $vars[1]:\n$vars[0]\n";}
	my %info = ();
	$info{"chr"}	= $col[0];
	$info{"start"}	= $col[1];
	$info{"end"}	= $col[2];
	$info{"id"}	= $col[3];
	$info{"strand"}	= $col[4];
	$info{"dis"}	= abs($col[6])+2;
	$info{"pscore"}	= $col[12];
	$info{"score"} 	= 1/log($info{"dis"})+0.0608*$info{"pscore"};
	return %info;
}
1;
